﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace KvadratickaRovniceWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        #region Výpočty
        /// <summary>
        /// Výpočet lineární rovnice
        /// </summary>
        /// <param name="b"> koeficient v lineárním členu </param>
        /// <param name="c"> absolutní člen </param>
        private void LinearniRovnice(double b, double c)
        {
            // Pokud první parametr je roven nule potom...
            if (b == 0)
                // Pokud druhý parametr je roven 0 potom...
                if (c == 0)
                    // Nekonečně mnoho řešení - vypsání textu v konzole
                    this.TxtVysledek.Text = "Nekonečně mnoho řešení - každé x";
                // Jinak...
                else
                    // Žádné řešení
                    this.TxtVysledek.Text = "Žádné řešení - žádné x";
            else
                // Vypočtení hodnoty kořenu - vypsání textu v konzole
                this.TxtVysledek.Text = "Lineární rovnice - kořen je: x = " + (-c / b);
        }

        /// <summary>
        /// Výpočet reálných kořenů kvadr. rovnice
        /// </summary>
        /// <param name="a"> koeficient v kvadratickém členu </param>
        /// <param name="b"> koeficient v lineárním členu </param>
        /// <param name="d"> diskriminant </param>
        private void RealneKoreny(double a, double b, double d)
        {
            /* Deklarace: 'x1' ... první reálný kořen kvadr. rovnice; 
             * 'x2' ... druhý reálný kořen kvadr. rovnice */
            double x1, x2;
            // Výpočet prvního kořenu
            x1 = (-b + Math.Sqrt(d)) / (2 * a);
            x2 = (-b - Math.Sqrt(d)) / (2 * a);

            this.TxtVysledek.Text = "Kořeny jsou:\n  x1 = " + x1.ToString() +
                "\n  x2 = " + x2.ToString();
        }

        /// <summary>
        /// Výpočet komplexně sdružených kořenů
        /// </summary>
        /// <param name="a"> koeficient v kvadratickém členu </param>
        /// <param name="b"> koeficient v lineárním členu </param>
        /// <param name="d"> diskriminant </param>
        private void KomplexniKoreny(double a, double b, double d)
        {
            /* Deklarace: 're' ... reálná složka kořenu kvadr. rovnice; 
             * 'im' ... imaginární složka kořenu kvadr. rovnice */
            double re, im;
            // Výpočet reálné složky kořenu kvadr. rovnice
            re = -b / (2 * a);
            // Výpočet imaginární složky kořenu kvadr. rovnice
            im = Math.Sqrt(Math.Abs(d)) / (2 * a);

            this.TxtVysledek.Text = "Kořeny jsou komplexní:\n  x1 = " + re.ToString() + " + " +
               im.ToString() + "i" + System.Environment.NewLine + "x2 = " + re.ToString() + " - " + im.ToString() + "i";
        }

        private void DvojityKoren(double a, double b)
        {
            // Dvojitý reálný kořen kvadr. rovnice
            double x;
            // Výpočet dvojitého reálného kořenu
            x = -b / (2 * a);
            // Vypočtení hodnoty dvojitého reálného kořenu - vypsání textu v konzole
            this.TxtVysledek.Text = "Dvojitý reálný kořen je:\n  x = " + x.ToString();
        }

        #endregion

        #region Události
        private void BtnKonec_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void BtnVypocti_Click(object sender, RoutedEventArgs e)
        {
            /* Deklarace: 'a' ... koeficient v kvadratickém členu;  'b' ... koeficient 
             * v lineárním členu; 'c' ... absolutní člen; * 'd' ... diskriminant */
            double a, b, c, d;

            //a = double.Parse(this.TxtA.Text);

            if (double.TryParse(this.TxtA.Text, out a) == false)
                MessageBox.Show("Špatně zadaná hodnota A, program počítá s 0.0"); 
            linear;

        }

        #endregion


    }
}
